//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2

//
//
//
//
//

extern int QwmaPeriod = 20;
extern int Price      =  0; 

//
//
//
//
//

double qWma[];
double cena[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,qWma);
      SetIndexBuffer(1,cena);
            Price      = MathMax(MathMin(Price,6),0);
            QwmaPeriod = MathMax(QwmaPeriod,1);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();

   if(QwmaPeriod>=Bars) return( 0);
   if(counted_bars<0)   return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      cena[i]=iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double sump=0;
      double sumw=0;
         for (int j=0; j<QwmaPeriod && (i+j)<Bars; j++)
         {
            double q = (QwmaPeriod-j)*(QwmaPeriod-j);
               sumw += q;
               sump += cena[i+j]*q;
         }               
         qWma[i]=sump/sumw;
   }
   return(0);
}